<?php
/*
================================================================
  Custom Field on Edit Page Example
  for EllisLab ExpressionEngine
----------------------------------------------------------------
  NoCopyright (c) 2008 MaxUp!WiseUpStudio
================================================================
  THIS IS COPYRIGHTED SOFTWARE. PLEASE
  READ THE LICENSE AGREEMENT.
----------------------------------------------------------------
  This software is based upon and derived from
  EllisLab ExpressionEngine software protected under
  copyright dated 2005 - 2008. Please see
  http://expressionengine.com/docs/license.html
----------------------------------------------------------------
  USE THIS SOFTWARE AT YOUR OWN RISK. WE ASSUME
  NO WARRANTY OR LIABILITY FOR THIS SOFTWARE AS DETAILED
  IN THE LICENSE AGREEMENT.
================================================================
  File:     ext.edit_custom_field.php
----------------------------------------------------------------
  Version:    0.0.0
----------------------------------------------------------------
  Purpose:    
----------------------------------------------------------------
  Compatibility:  EE 1.6.6
----------------------------------------------------------------
  Created:    2008-11-21
================================================================
*/
if ( ! defined('EXT')) exit('Invalid file request');

// -----------------------------------------
//  Begin class
// -----------------------------------------
class edit_custom_field
{
  /**
  * Extension settings
  * @var array
  */
  var $settings   = array();
  
  var $name     = 'Custom Field on Edit Page Example';

  /**
  * Extension version
  * @var string
  */
  var $version     = '0.0.0';

  /**
  * Extension description
  * @var string
  */
  var $description   = '';
  
  /**
  * If $settings_exist = 'y' then a settings page will be shown in the ExpressionEngine admin
  * @var string
  */  
  var $settings_exist  = 'y';

  /**
  * Link to extension documentation
  * @var string
  */
	var $docs_url   = '';

	function edit_custom_field($settings='')
	{
		$this->settings = $settings;
	}
  
	function settings()
	{
		$settings = array();
		$settings['field_label'] = 'English Title';
		$settings['date_format'] = '';
		return $settings;
	}

	function activate_extension()
	{
		global $DB;
    
		$default_settings = serialize(
			array(
			  'field_label' => "",
			  'date_format' => "%Y %m %d"
			)
		);

		$hooks = array(
				'edit_entries_additional_tableheader' => 'edit_entries_additional_tableheader',
				'edit_entries_additional_celldata'    => 'edit_entries_additional_celldata'
        		  );

		foreach ($hooks as $hook => $method)
		{
		$sql[] = $DB->insert_string('exp_extensions',
					array(
                    'extension_id' => '',
                    'class'   => get_class($this),
                    'method'  => $method,
                    'hook'     =>$hook,
                    'settings'  => $default_settings,
                    'priority'  => 10,
                    'version' => $this->version,
                    'enabled' => "y"
                    )
                  );
		}

		foreach ($sql as $query)
		{
			$DB->query($query);
		}
	    
		return TRUE;

	}

	function edit_entries_additional_tableheader()
	{
		global $DSP, $EXT, $DB;
		
		if (empty($this->settings['field_label'])) {
		  return;
		}
		
		$query = $DB->query("SELECT field_label FROM exp_weblog_fields WHERE field_label='".$this->settings['field_label']."'");		

		foreach($query->result as $file_field)
		{
			$field_label = $file_field['field_label'];
		}
		
		
		
		$extra = ($EXT->last_call !== FALSE) ? $EXT->last_call : '';
		
		return $extra.$DSP->table_qcell('tableHeadingAlt', $field_label);
	}
	
	function edit_entries_additional_celldata($row)
	{	
		global $DSP, $EXT, $DB, $row_count,$LOC; 
        
        if (empty($row_count))
        {
        	$row_count=0;
        }
        $style = ($row_count % 2) ? 'tableCellOne' : 'tableCellTwo'; $row_count++;
		
		if (empty($this->settings['field_label'])) {
		  return;
		}
		
		$field_data="-";
		
		// get the field ID for that row with that label
		
		$q = $DB->query("SELECT field_id FROM exp_weblog_fields 
						LEFT JOIN exp_weblogs ON exp_weblog_fields.group_id = exp_weblogs.field_group
						LEFT JOIN exp_weblog_data ON exp_weblog_data.weblog_id = exp_weblogs.weblog_id
						WHERE 
							exp_weblog_fields.field_label='".$this->settings['field_label']."'
							AND
							exp_weblog_data.entry_id='".$row['entry_id']."'");	
		
		foreach($q->result as $field_ids)
		{
			$field_id = $field_ids['field_id'];
		}
		
		if (! empty($field_id))
		{	
			
		
			$this->settings['field_id'] = $field_id;
			
			$customfield = 'field_id_'.$this->settings['field_id'];
			
			$query = $DB->query("SELECT ".$customfield." FROM exp_weblog_data WHERE entry_id='".$row['entry_id']."'");	
				
			$query2 = $DB->query("SELECT field_type FROM exp_weblog_fields WHERE field_id='".$this->settings['field_id']."'");
			
			foreach($query2->result as $file_field)
			{
				$field_type = $file_field['field_type'];
			}
			
			foreach($query->result as $file_field)
			{
			
				$field_data = ($field_type == "date") ? $LOC->decode_date($this->settings['date_format'], $file_field[$customfield]) : $file_field[$customfield];
			}
			
		}
		else
		{
			$field_data = "";
		}
		
		$extra = ($EXT->last_call !== FALSE) ? $EXT->last_call : '';
		
		return $extra.$DSP->table_qcell($style, $field_data);
	}

 
// --------------------------------
//  Update Extension
// --------------------------------

  function update_extension($current='')
  {
    global $DB;

    if ($current == '' OR $current == $this->version)
    {
      return FALSE;
    }

    if ($current > '1.0')
    {
      // Update to next version
    }

    $DB->query("UPDATE exp_extensions 
          SET version = '".$DB->escape_str($this->version)."' 
          WHERE class = '" . get_class($this) . "'");
  }

// --------------------------------
//  Disable Extension
// --------------------------------
  function disable_extension()
  {
    global $DB;
    $DB->query("DELETE FROM `exp_extensions` WHERE class = '" . get_class($this) . "'");
  }

}
// END CLASS
?>