<?php
/**
* English language file for LG .htaccess Generator
* 
* This file must be placed in the
* /system/language/english/ folder in your ExpressionEngine installation.
*
* @package LgHtaccessGenerator
* @version 1.0.0
* @author Leevi Graham <http://leevigraham.com>
* @see http://leevigraham.com/cms-customisation/expressionengine/addon/lg-htaccess-generator/
* @copyright Copyright (c) 2007-2008 Leevi Graham
* @license {@link http://creativecommons.org/licenses/by-sa/3.0/ Creative Commons Attribution-Share Alike 3.0 Unported} All source code commenting and attribution must not be removed. This is a condition of the attribution clause of the license.
*/

global $PREFS;

$L = array(

"lg_htaccess_generator_title" => "LG .htaccess Generator",

'access_rights' 			=> 'Extension Access',
'enable_extension_for_this_site' => 'Enable LG .htaccess Generator for this site?',

'which_groups_are_allowed_to_update_htaccess_label'	=> 'Which member groups can generate a .htaccess file?',
'which_weblogs_label' 		=> 'Which ' . $PREFS->ini('weblog_nomenclature') . 's will display a LG .htaccess tab?',
'no_weblogs_msg' 			=> 'There are no '  . $PREFS->ini('weblog_nomenclature') . 's assigned to this site.',

'no_weblogs_msg'			=> 'No weblogs have been setup',

'htaccess_options'			=> '.htaccess Generation Options',
'htaccess_options_info'		=> '<p>LG .htaccess Generator requires that an existing .htaccess file exists and is writable. If the file contains existing rules these will not be modified.</p>
								<p style="margin-top:9px">The rules below will be added to your .htaccess file after the following special tags are replaced:</p>
								<ul>
									<li><strong><code>{ee:template_groups}</code></strong> will be replaced with a pipe delimited list of this sites template groups</li>
									<li><strong><code>{ee:pages}</code></strong> will be replaced with a pipe delimited list of this sites page urls</li>
									<li><strong><code>{ee:404}</code></strong> will be replaced with the sites 404 path ie: site/404</li>
								</ul>
								<p>Read more about the "include method" of removing your sites index.php on the <a rel="external" target="_blank" href="http://expressionengine.com/index.php?affiliate=leevi&amp;page=/wiki/Remove_index.php_From_URLs/#Include_List_Method">ExpressionEngine Wiki</a>.',
'www_handling_label'		=> 'How would you like to handle the www. in the url?',
'www_handling_nothing'		=> 'Do nothing, I\'ll let my server handle it',
'www_handling_add'			=> 'Add www. to the url',
'www_handling_remove'		=> 'Remove www. from the url',

'htaccess_path_label'		=> 'The server directory where your .htaccess will be generated',
'htaccess_rules_label'		=> ".htaccess rules",

'scripts' 					=> 'Scripts',
'scripts_info' 				=> 'LG .htaccess Generator requires <a href="http://jquery.com">jQuery Core v1.2.6+</a> to work correctly.',
'jquery_core_path_label'	=> 'jQuery Core v1.2.6+ URL',

'check_for_updates_title' 	=> 'Check for updates?',
'check_for_updates_info' 	=> 'LG .htaccess Generator can call home (<a href="http://leevigraham.com/">http://leevigraham.com</a>) and check for recent updates.',
'check_for_updates_label' 	=> 'Would you like this extension to check for updates and display them on your CP homepage?',

'donation'					=> 'This extension was developed by <a href="http://leevigraham.com">Leevi Graham</a>. <br />Support its development by donating.',
'lg_admin_title'			=> 'LG Admin Options',
'show_donate_label'			=> 'Show the donation link at the top of the settings page?',
'show_promos_label'			=> 'Show promos at the top of the settings page?',

'htaccess_generated'		=> 'Your .htaccess file has been generated successfully.',

'htaccess_not_writable'		=> 'Your .htaccess could not be found or is not writable. Please check the .htaccess file exists and has the correct permissions.',
'dir_doesnt_exist'			=> 'Your .htaccess directory does not exist.',
'htaccess_generated_error'	=> 'There was an error generating your .htaccess file.',

// END
''=>''
);
?>